/* Code generated by cmd/cgo; DO NOT EDIT. */

/* package github.com/eduvpn/eduvpn-common/exports */


#line 1 "cgo-builtin-export-prolog"

#include <stddef.h>

#ifndef GO_CGO_EXPORT_PROLOGUE_H
#define GO_CGO_EXPORT_PROLOGUE_H

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef struct { const char *p; ptrdiff_t n; } _GoString_;
#endif

#endif

/* Start of preamble from import "C" comments.  */


#line 3 "disco.go"

// for free and size_t
#include <stdlib.h>
#include "error.h"

typedef struct discoveryServer {
  const char* authentication_url_template;
  const char* base_url;
  const char* country_code;
  const char* display_name;
  const char* keyword_list;
  const char** public_key_list;
  size_t total_public_keys;
  const char* server_type;
  const char** support_contact;
  size_t total_support_contact;
} discoveryServer;

typedef struct discoveryServers {
  unsigned long long int version;
  discoveryServer** servers;
  size_t total_servers;
} discoveryServers;

typedef struct discoveryOrganization {
  const char* display_name;
  const char* org_id;
  const char* secure_internet_home;
  const char* keyword_list;
} discoveryOrganization;

typedef struct discoveryOrganizations {
  unsigned long long int version;
  discoveryOrganization** organizations;
  size_t total_organizations;
} discoveryOrganizations;

#line 1 "cgo-generated-wrapper"

#line 3 "exports.go"

#include <stdlib.h>
#include "error.h"
#include "server.h"

typedef long long int (*ReadRxBytes)();
typedef struct token {
    const char* access;
    const char* refresh;
    unsigned long long int expired;
} token;

typedef void (*UpdateToken)(const char* name, server* srv, token* tok);

typedef struct configData {
    const char* config;
    const char* config_type;
    token* tokens;
} configData;

typedef int (*PythonCB)(const char* name, int oldstate, int newstate, void* data);

static long long int get_read_rx_bytes(ReadRxBytes read)
{
   return read();
}

static void update_token(UpdateToken func, const char* name, server* srv, token* tok)
{
   func(name, srv, tok);
}

static int call_callback(PythonCB callback, const char *name, int oldstate, int newstate, void* data)
{
    return callback(name, oldstate, newstate, data);
}

#line 1 "cgo-generated-wrapper"

#line 3 "servers.go"

// for free and size_t
#include <stdlib.h>
#include "error.h"
#include "server.h"

#line 1 "cgo-generated-wrapper"


/* End of preamble from import "C" comments.  */


/* Start of boilerplate cgo prologue.  */
#line 1 "cgo-gcc-export-header-prolog"

#ifndef GO_CGO_PROLOGUE_H
#define GO_CGO_PROLOGUE_H

typedef signed char GoInt8;
typedef unsigned char GoUint8;
typedef short GoInt16;
typedef unsigned short GoUint16;
typedef int GoInt32;
typedef unsigned int GoUint32;
typedef long long GoInt64;
typedef unsigned long long GoUint64;
typedef GoInt64 GoInt;
typedef GoUint64 GoUint;
typedef size_t GoUintptr;
typedef float GoFloat32;
typedef double GoFloat64;
#ifdef _MSC_VER
#include <complex.h>
typedef _Fcomplex GoComplex64;
typedef _Dcomplex GoComplex128;
#else
typedef float _Complex GoComplex64;
typedef double _Complex GoComplex128;
#endif

/*
  static assertion to make sure the file is being used on architecture
  at least with matching size of GoInt.
*/
typedef char _check_for_64_bit_pointer_matching_GoInt[sizeof(void*)==64/8 ? 1:-1];

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef _GoString_ GoString;
#endif
typedef void *GoMap;
typedef void *GoChan;
typedef struct { void *t; void *v; } GoInterface;
typedef struct { void *data; GoInt len; GoInt cap; } GoSlice;

#endif

/* End of boilerplate cgo prologue.  */

#ifdef __cplusplus
extern "C" {
#endif

extern void FreeDiscoServers(discoveryServers* cServers);
extern void FreeDiscoOrganizations(discoveryOrganizations* cOrganizations);

/* Return type for GetDiscoServers */
struct GetDiscoServers_return {
	discoveryServers* r0;
	error* r1;
};
extern struct GetDiscoServers_return GetDiscoServers(char* name);

/* Return type for GetDiscoOrganizations */
struct GetDiscoOrganizations_return {
	discoveryOrganizations* r0;
	error* r1;
};
extern struct GetDiscoOrganizations_return GetDiscoOrganizations(char* name);
extern error* Register(char* name, char* version, char* configDirectory, char* language, PythonCB stateCallback, int debug);
extern error* SetTokenUpdater(char* name, UpdateToken updater);
extern error* Deregister(char* name);
extern void FreeError(error* err);
extern error* CancelOAuth(char* name);
extern error* RemoveSecureInternet(char* name);
extern error* AddInstituteAccess(char* name, char* url);
extern error* AddSecureInternetHomeServer(char* name, char* orgID);
extern error* AddCustomServer(char* name, char* url);
extern error* RemoveInstituteAccess(char* name, char* url);
extern error* RemoveCustomServer(char* name, char* url);
extern void FreeTokens(token* tokens);
extern void FreeConfig(configData* config);

/* Return type for GetConfigSecureInternet */
struct GetConfigSecureInternet_return {
	configData* r0;
	error* r1;
};
extern struct GetConfigSecureInternet_return GetConfigSecureInternet(char* name, char* orgID, int preferTCP, token prevTokens);

/* Return type for GetConfigInstituteAccess */
struct GetConfigInstituteAccess_return {
	configData* r0;
	error* r1;
};
extern struct GetConfigInstituteAccess_return GetConfigInstituteAccess(char* name, char* url, int preferTCP, token prevTokens);

/* Return type for GetConfigCustomServer */
struct GetConfigCustomServer_return {
	configData* r0;
	error* r1;
};
extern struct GetConfigCustomServer_return GetConfigCustomServer(char* name, char* url, int preferTCP, token prevTokens);
extern error* SetProfileID(char* name, char* data);
extern error* ChangeSecureLocation(char* name);
extern error* SetSecureLocation(char* name, char* data);
extern error* GoBack(char* name);
extern error* SetSearchServer(char* name);
extern error* Cleanup(char* name, token prevTokens);
extern error* SetDisconnected(char* name);
extern error* SetDisconnecting(char* name);
extern error* SetConnecting(char* name);
extern error* SetConnected(char* name);
extern error* RenewSession(char* name);
extern int ShouldRenewButton(char* name);
extern int InFSMState(char* name, int checkState);
extern error* SetSupportWireguard(char* name, int support);

/* Return type for StartFailover */
struct StartFailover_return {
	int r0;
	error* r1;
};
extern struct StartFailover_return StartFailover(char* name, char* gateway, int mtu, ReadRxBytes readRxBytes);
extern error* CancelFailover(char* name);
extern void FreeString(char* addr);

// Free the profiles by looping through them if there are any
// Also free the pointer itself
//
extern void FreeProfiles(serverProfiles* profiles);

// Function for freeing a single server
// Gets the pointer to C struct
//
extern void FreeServer(server* info);

// This function takes the servers as a C struct pointer as input
// It frees all allocated memory for the server
//
extern void FreeServers(servers* cServers);

/* Return type for GetSavedServers */
struct GetSavedServers_return {
	servers* r0;
	error* r1;
};

// This function takes the name as input which is the name of the client
// It gets the state by name and then returns the saved servers as a c struct belonging to it
//
extern struct GetSavedServers_return GetSavedServers(char* name);

/* Return type for GetCurrentServer */
struct GetCurrentServer_return {
	server* r0;
	error* r1;
};

// This function takes the name as input which is the name of the client
// It gets the state by name and then returns the current server as a c struct belonging to it
//
extern struct GetCurrentServer_return GetCurrentServer(char* name);
extern void FreeSecureLocations(serverLocations* locations);

#ifdef __cplusplus
}
#endif
